{-
 -
 - APCC
 - (C) Ivana Kojovic, DTU 2012
 - All Rights Reserved.
 -
 -
 -
 -}

-- | @Checker@ is a main module. 
module Checker (disjointCheck, protocolsEST,putNameInsideMessages) where 
import Message
import Unification
import FormatTypeSafe
import EncryptedPattern
import qualified Data.Map as Map
import Control.Monad.State
import Data.List

type StateValue = [Map.Map (Message,String) MessageType]

-- | from every protocol we make "huge" set of all the non atomic subterm
--
protocolsEST :: [[((Message,String), MessageType)]] -> State StateEMP StateValue --  [[(Message, MessageType)]] 

protocolsEST [] = do
        (state,counter) <- get
        return state

protocolsEST (x:xs) = do
        (state,counter) <- get
        let newElem = makeEST (x,counter)
         in put ((fst newElem) : state, snd newElem)
        protocolsEST(xs)


putNameInsideMessages :: ([(Message,MessageType)], String) -> [((Message,String),MessageType)]
putNameInsideMessages ([],protocolName) = []
putNameInsideMessages ((msg,msgType):arrayTail, protocolName) = ((msg,protocolName),msgType): (putNameInsideMessages (arrayTail,protocolName))

-- | Central check function. It takes protocols and gives confirmation for its composition.
-- Here should be check also condition from parallel composition.
-- Function callse unifyEmp function
disjointCheck :: [([(Message, MessageType)], String)] -> Bool    ---- done!
--disjointCheck [single] = theoremNum1 single
disjointCheck protocols = let est = (evalState (protocolsEST (map putNameInsideMessages protocols)) ([], 0))
                           in unifyEMP(est) -- unifyEMP takes the argument of the same type here like for checking all the EMPi





